﻿package game {
	import flash.display.*;
	import flash.events.*;
	import game.Player;
	
	public class Obstacle extends MovieClip {
		
		public var xSpeed:Number;
		public var isStatic:Boolean;
		public var isGround:Boolean;
		private var isActiveMove:Boolean;
		public var isOut:Boolean;
		
		public function Obstacle(xSpeed:int = -3) {
			this.xSpeed = xSpeed;
			this.isStatic = false;
			this.isGround = false;
			this.isActiveMove = false;
			this.isOut = false;
			
			this.addEventListener(Event.ENTER_FRAME, moveBlock);
			this.addEventListener(Event.REMOVED_FROM_STAGE, dispose);
		}
		
		
		
		
		
		public function activeMove(){
			this.isActiveMove = true;
		}
		
		function moveBlock(event:Event):void {
			if (!isStatic && this.x + this.width < 0)	{
				this.isActiveMove = false;
				this.isOut = true;
				//this.removeEventListener(Event.ENTER_FRAME, moveBlock);
				//this.parent.removeChild(this);
			}
			
			if (!isStatic && isActiveMove) {
				this.x += this.xSpeed;
			}
		}
		
		function dispose(event:Event):void {
			this.removeEventListener(Event.ENTER_FRAME, moveBlock);
			this.removeEventListener(Event.REMOVED_FROM_STAGE, dispose);
		}
		
	}
}