﻿
package game {
	import game.*;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	import flash.display.DisplayObjectContainer;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.media.SoundChannel;
	
	
	public class ScrollingRace extends MovieClip {
		public var player:Player;
		public var flics:Flics;
		public var backgroundClip:Stage;
		public var score:Number = 0;
		var baseScoreIncrease:Number = 4/30; // 14,4 km/h
		var fastScoreIncrease:Number = 7/30; // 25,2 km/h
		var slowScoreIncrease:Number = 2/30; //  7,2 km/h
		var currentScoreIncrease:Number = baseScoreIncrease;
		var scoreText:NiceTextField;
		
		var vie1:ArbreVie;
		var vie2:ArbreVie;
		var vie3:ArbreVie;
		
		var sndChannel:SoundChannel;
		
		var display:DisplayObjectContainer;
		var yGroundPosition:Number = 450;
		var xFlicsPosition:Number = 70;
		var isSarkoShowed:Boolean = false;
		var isSarkoHided:Boolean = true;
		
		var spaceIsDown:Boolean;
		var rightKeyIsDown:Boolean;
		var leftKeyIsDown:Boolean;
		var upKeyIsDown:Boolean;
		var downKeyIsDown:Boolean;
		
		var gameOverCallback:Function;
		var echelle:Number;
		
		var escapeCounter:Number = 0;
		var compteurNiveau:Number = 0;
		var escapeMessage:NiceTextField = null;
		
		var compteur:int = 0;
		var reglage:int = 10;
		
		//declaration d'obstacles
		var deco_stone:Deco_stone = new Deco_stone();
		var deco_barriere:Deco_barriere = new Deco_barriere();
		var deco_flecheRight:Deco_flecheRight = new Deco_flecheRight();
		var deco_flecheUp:Deco_flecheUp = new Deco_flecheUp();
		var deco_panneau:Deco_panneau = new Deco_panneau();
		var deco_plot1:Deco_plot1 = new Deco_plot1();
		var deco_plot2:Deco_plot2 = new Deco_plot2();
		var deco_voiture:Deco_voiture = new Deco_voiture();
		var flecheRightDebut:Deco_flecheRight = new Deco_flecheRight();
		var flecheUpDebut:Deco_flecheUp = new Deco_flecheUp();
		
		var boite1_1:Boite1_1 = new Boite1_1();
		var boite1_2:Boite1_2 = new Boite1_2();;
		var boite1_3:Boite1_3 = new Boite1_3();;
		var boite1_4:Boite1_4 = new Boite1_4();;
		var boite1_5:Boite1_5 = new Boite1_5();;
		var boite1Ens:Boolean = true;
		
		var etage1_box1:Etage1_box = new Etage1_box();
		var etage1_box2:Etage1_box = new Etage1_box();
		var etage1_box3:Etage1_box = new Etage1_box();
		var etage1_haut:Etage1_haut = new Etage1_haut();
		var etage1_bas:Etage1_bas = new Etage1_bas();
		var etage1Ens:Boolean = true;
		
		var etage2_box1:Etage2_box1 = new Etage2_box1();
		var etage2_bas1:Etage2_bas1 = new Etage2_bas1();
		var etage2_bas2:Etage2_bas1 = new Etage2_bas1();
		var etage2_haut1:Etage2_hautMiddle = new Etage2_hautMiddle();
		var etage2_bas3:Etage2_bas3 = new Etage2_bas3();
		var etage2_bas4:Etage2_bas3 = new Etage2_bas3();
		var etage2_haut2:Etage2_hautLong = new Etage2_hautLong();
		var etage2_bas5:Etage2_bas1 = new Etage2_bas1();
		var etage2_haut3:Etage2_hautCourt = new Etage2_hautCourt();
		var etage2_pierre1:Etage2_pierre2 = new Etage2_pierre2();
		var etage2_sac1:Etage2_sac = new Etage2_sac();
		var etage2_box2:Etage2_box2 = new Etage2_box2();
		var etage2_box3:Etage2_box2 = new Etage2_box2();
		var etage2_box4:Etage2_box2 = new Etage2_box2();
		var etage2_box5:Etage2_box2 = new Etage2_box2();
		var etage2_box6:Etage2_box2 = new Etage2_box2();
		var etage2_box7:Etage2_box2 = new Etage2_box2();
		var etage2_bas6:Etage2_bas3 = new Etage2_bas3();
		var etage2_bas7:Etage2_bas3 = new Etage2_bas3();
		var etage2_bas8:Etage2_bas1 = new Etage2_bas1();
		var etage2_bas9:Etage2_bas2 = new Etage2_bas2();
		var etage2_bas10:Etage2_bas2 = new Etage2_bas2();
		var etage2_bas11:Etage2_bas6 = new Etage2_bas6();
		var etage2_haut4:Etage2_hautLong = new Etage2_hautLong();
		var etage2_haut5:Etage2_hautLong = new Etage2_hautLong();
		var etage2_haut6:Etage2_hautCourt = new Etage2_hautCourt();
		var etage2_pierre2:Etage2_pierre2 = new Etage2_pierre2();
		var etage2_box8:Etage2_box2 = new Etage2_box2();
		var etage2_box9:Etage2_box2 = new Etage2_box2();
		var etage2_box10:Etage2_box1 = new Etage2_box1();
		var etage2_box11:Etage2_box1 = new Etage2_box1();
		var etage2_box12:Etage2_box1 = new Etage2_box1();
		
		var etage2Ens:Boolean = true;
		
		
		
		
		var speedPlayer = 8.0;
		var xSpeed = -3.0;
		
		public function ScrollingRace(d:DisplayObjectContainer, playerType:Number, callback:Function, scoreText:NiceTextField) {
			display = d;
			gameOverCallback = callback;
					
			// création du fond
			backgroundClip = new Stage();
			backgroundClip.scaleX = backgroundClip.scaleY = 1;
			backgroundClip.x = 0;
			backgroundClip.y = 0;
			this.addChild(backgroundClip);
			
			
			// création du joueur
			switch (playerType) {
				case 1:
					player = new ArabePlayer();
					break;
				case 2:
					player = new ChinesePlayer();
					break;
				default:
					player = new BlackPlayer();
			}
			player.standingSpeed = xSpeed;
			player.baseSpeed = speedPlayer;
			player.ySpeedOnJump = 0;
			player.yDecrease = 1.5;
			player.initialJumpSpeed = 17;
			player.x = display.stage.stageWidth / 2;
			player.y = yGroundPosition - player.height;
			player.start();
			
			// musique
			// création d'un sol
			var obstacle = new Obstacle();
			obstacle.isStatic = true;
			obstacle.isGround = true;
			obstacle.width = display.stage.stageWidth;
			obstacle.x = 0;
			obstacle.y = yGroundPosition;
			obstacle.visible = false;
			this.addChild(obstacle);
			player.obstacles.addItems(obstacle);
			
			// création d'un mur à droite
			obstacle = new Obstacle();
			obstacle.isStatic = true;
			obstacle.height = display.stage.stageHeight;
			obstacle.width *= 5;
			obstacle.x = display.stage.stageWidth - 50;
			obstacle.y = 0;
			obstacle.visible = false;
			this.addChild(obstacle);
			player.obstacles.addItems(obstacle);
			
			// création d'un mur à gauche
			obstacle = new Obstacle();
			obstacle.isStatic = true;
			obstacle.height = display.stage.stageHeight;
			obstacle.x = 0 - obstacle.width;
			obstacle.y = 0;
			obstacle.visible = false;
			this.addChild(obstacle);
			player.obstacles.addItems(obstacle);
			
			//ajout d'obstacle
			flecheRightDebut.x = 600;
			flecheRightDebut.y = yGroundPosition - flecheRightDebut.height - reglage;
			this.addChild(flecheRightDebut);
			deco_stone.x = 1500;
			deco_stone.y = yGroundPosition - deco_stone.height - reglage;
			this.addChild(deco_stone);
			deco_barriere.x = 1500;
			deco_barriere.y = yGroundPosition - deco_barriere.height - reglage;
			this.addChild(deco_barriere);
			deco_flecheRight.x = 1500;
			deco_flecheRight.y = yGroundPosition - deco_flecheRight.height - reglage;
			this.addChild(deco_flecheRight);
			deco_panneau.x = 1500;
			deco_panneau.y = yGroundPosition - deco_panneau.height - reglage;
			this.addChild(deco_panneau);
			deco_plot1.x = 1500;
			deco_plot1.y = yGroundPosition - deco_plot1.height - reglage;
			this.addChild(deco_plot1);
			deco_plot2.x = 1500;
			deco_plot2.y = yGroundPosition - deco_plot2.height - reglage;
			this.addChild(deco_plot2);
			deco_voiture.x = 1500;
			deco_voiture.y = yGroundPosition - deco_voiture.height - reglage;
			this.addChild(deco_voiture);
			deco_flecheUp.x = 1500;
			deco_flecheUp.y = yGroundPosition - deco_flecheUp.height - reglage;
			this.addChild(deco_flecheUp);
			
			
			//pour des boites combines
			boite1_1.x = 1500;
			boite1_1.y = yGroundPosition - boite1_1.height + reglage;
			this.addChild(boite1_1);
			player.obstacles.addItems(boite1_1);
			boite1_2.x = boite1_1.x + boite1_1.width;
			boite1_2.y = yGroundPosition - boite1_2.height + reglage;
			this.addChild(boite1_2);
			player.obstacles.addItems(boite1_2);
			boite1_3.x = boite1_2.x + boite1_2.width;
			boite1_3.y = yGroundPosition - boite1_3.height + reglage;
			this.addChild(boite1_3);
			player.obstacles.addItems(boite1_3);
			boite1_4.x = boite1_3.x + boite1_3.width;
			boite1_4.y = yGroundPosition - boite1_4.height + reglage;
			this.addChild(boite1_4);
			player.obstacles.addItems(boite1_4);
			boite1_5.x = boite1_4.x + boite1_4.width;
			boite1_5.y = yGroundPosition - boite1_5.height + reglage;
			this.addChild(boite1_5);
			player.obstacles.addItems(boite1_5);
			
			//pour un petit sault
			etage1_box1.x = 1500;
			etage1_box1.y = yGroundPosition - etage1_box1.height + reglage;
			this.addChild(etage1_box1);
			player.obstacles.addItems(etage1_box1);
			//
			etage1_haut.x = etage1_box1.x + etage1_box1.width + speedPlayer*10;
			etage1_haut.y = yGroundPosition - etage1_haut.height - etage1_bas.height + reglage;
			this.addChild(etage1_haut);
			player.obstacles.addItems(etage1_haut);
			//
			etage1_bas.x = etage1_haut.x + etage1_haut.width/2 - etage1_bas.width/2;
			etage1_bas.y = yGroundPosition - etage1_bas.height + reglage;
			this.addChild(etage1_bas);
			//
			etage1_box2.x = etage1_haut.x + etage1_haut.width + speedPlayer*10;
			etage1_box2.y = yGroundPosition - etage1_box2.height + reglage;
			this.addChild(etage1_box2);
			player.obstacles.addItems(etage1_box2);
			//
			etage1_box3.x = etage1_haut.x + etage1_haut.width + speedPlayer*10;
			etage1_box3.y = yGroundPosition - etage1_box2.height*2 + reglage+5;
			this.addChild(etage1_box3);
			player.obstacles.addItems(etage1_box3);
			
			
			//pour le grand niveau
			
			flecheUpDebut.x = 1350;
			flecheUpDebut.y = yGroundPosition - flecheUpDebut.height - reglage;
			this.addChild(flecheUpDebut);
			etage2_box1.x = 1500;
			etage2_box1.y = yGroundPosition - etage2_box1.height + reglage;
			this.addChild(etage2_box1);
			player.obstacles.addItems(etage2_box1);
			//
			etage2_haut1.x = etage2_box1.x + etage2_box1.width + speedPlayer*7;
			etage2_haut1.y = yGroundPosition - etage2_haut1.height - etage2_bas1.height + reglage + 2;
			this.addChild(etage2_haut1);
			player.obstacles.addItems(etage2_haut1);
			//
			etage2_bas1.x = etage2_haut1.x + etage2_haut1.width/5 - etage2_bas1.width/2;
			etage2_bas1.y = yGroundPosition - etage2_bas1.height + reglage;
			this.addChild(etage2_bas1);
			//
			etage2_bas2.x = etage2_haut1.x + etage2_haut1.width*4/5 - etage2_bas2.width/2;
			etage2_bas2.y = yGroundPosition - etage2_bas1.height + reglage;
			this.addChild(etage2_bas2);
			//
			etage2_haut2.x = etage2_haut1.x + etage2_haut1.width + speedPlayer*10;
			etage2_haut2.y = yGroundPosition - etage2_haut1.height - etage2_bas3.height + reglage + 2;
			player.obstacles.addItems(etage2_haut2);
			//
			etage2_bas3.x = etage2_haut2.x + etage2_haut2.width/4 - etage2_bas3.width/2;
			etage2_bas3.y = yGroundPosition - etage2_bas3.height + reglage;
			this.addChild(etage2_bas3);
			//
			etage2_bas4.x = etage2_haut2.x + etage2_haut2.width*4/5 - etage2_bas4.width/2;
			etage2_bas4.y = yGroundPosition - etage2_bas4.height + reglage;
			this.addChild(etage2_bas4);
			//
			etage2_bas5.x = etage2_haut2.x + etage2_haut2.width/4 - etage2_bas3.width/2;
			etage2_bas5.y = etage2_haut2.y - etage2_bas5.height + reglage + 10;
			this.addChild(etage2_bas5);
			//
			etage2_haut3.x = etage2_bas5.x - 20;
			etage2_haut3.y = etage2_bas5.y - etage2_haut3.height + 2;
			this.addChild(etage2_haut3);
			player.obstacles.addItems(etage2_haut3);
			//
			etage2_pierre1.x = etage2_haut3.x + etage2_haut3.width - 20;
			etage2_pierre1.y = etage2_haut2.y - etage2_pierre1.height;
			this.addChild(etage2_pierre1);
			player.obstacles.addItems(etage2_pierre1);
			//
			etage2_sac1.x = etage2_pierre1.x + etage2_pierre1.width;
			etage2_sac1.y = etage2_haut2.y - etage2_sac1.height + 10;
			this.addChild(etage2_sac1);
			player.obstacles.addItems(etage2_sac1);
			//
			this.addChild(etage2_haut2);
			//
			etage2_box2.x = etage2_haut2.x + etage2_haut2.width + speedPlayer*10;
			etage2_box2.y = yGroundPosition - etage2_box2.height + reglage;
			this.addChild(etage2_box2);
			player.obstacles.addItems(etage2_box2);
			//
			etage2_box3.x = etage2_haut2.x + etage2_haut2.width + speedPlayer*10;
			etage2_box3.y = etage2_box2.y - etage2_box3.height + 2;
			this.addChild(etage2_box3);
			player.obstacles.addItems(etage2_box3);
			//
			etage2_box4.x = etage2_box2.x + etage2_box2.width + speedPlayer*10;
			etage2_box4.y = yGroundPosition - etage2_box4.height + reglage;
			this.addChild(etage2_box4);
			player.obstacles.addItems(etage2_box4);
			//
			etage2_box5.x = etage2_box2.x + etage2_box2.width + speedPlayer*10;
			etage2_box5.y = etage2_box4.y - etage2_box5.height + 2;
			this.addChild(etage2_box5);
			player.obstacles.addItems(etage2_box5);
			//
			etage2_box6.x = etage2_box4.x + etage2_box4.width + speedPlayer*10;
			etage2_box6.y = yGroundPosition - etage2_box6.height + reglage;
			this.addChild(etage2_box6);
			player.obstacles.addItems(etage2_box6);
			//
			etage2_box7.x = etage2_box4.x + etage2_box4.width + speedPlayer*10;;
			etage2_box7.y = etage2_box6.y - etage2_box7.height + 2;
			this.addChild(etage2_box7);
			player.obstacles.addItems(etage2_box7);
			//
			etage2_haut4.x = etage2_box6.x + etage2_box6.width + speedPlayer*10;
			etage2_haut4.y = yGroundPosition - etage2_bas6.height - etage2_haut4.height + reglage + 2;
			player.obstacles.addItems(etage2_haut4);
			//
			etage2_bas6.x = etage2_haut4.x + etage2_haut4.width/5 - etage2_bas6.width/2;
			etage2_bas6.y = yGroundPosition - etage2_bas6.height + reglage;
			this.addChild(etage2_bas6);
			//
			etage2_bas7.x = etage2_haut4.x + etage2_haut4.width*4/5 - etage2_bas6.width/2;
			etage2_bas7.y = yGroundPosition - etage2_bas7.height + reglage;
			this.addChild(etage2_bas7);
			//
			etage2_bas8.x = etage2_haut4.x + etage2_haut4.width*4/5 - etage2_bas8.width/2;
			etage2_bas8.y = etage2_haut4.y - etage2_bas8.height + reglage + 10;
			this.addChild(etage2_bas8);
			//
			this.addChild(etage2_haut4);
			//
			etage2_haut5.x = etage2_bas8.x - 20;
			etage2_haut5.y = etage2_bas8.y - etage2_haut5.height + 2;
			player.obstacles.addItems(etage2_haut5);
			//
			etage2_bas9.x = etage2_haut5.x + etage2_haut5.width*2/3 - etage2_bas9.width/2;
			etage2_bas9.y = etage2_haut5.y - etage2_bas9.height  + 10;
			this.addChild(etage2_bas9);
			//
			etage2_pierre2.x = etage2_bas9.x - etage2_pierre2.width - 50;
			etage2_pierre2.y = etage2_haut5.y - etage2_pierre2.height +5;
			player.obstacles.addItems(etage2_pierre2);
			this.addChild(etage2_pierre2);
			//
			etage2_haut6.x = etage2_bas9.x - 10;
			etage2_haut6.y = etage2_bas9.y - etage2_haut6.height + 2;
			player.obstacles.addItems(etage2_haut6);
			//
			etage2_bas10.x = etage2_haut6.x + etage2_haut6.width*3/4 - etage2_bas10.width/2;
			etage2_bas10.y = etage2_haut5.y - etage2_bas10.height  + 10;
			this.addChild(etage2_bas10);
			//
			etage2_bas11.x = etage2_haut6.x + etage2_haut6.width*3/4 - etage2_bas10.width/2;
			etage2_bas11.y = yGroundPosition - etage2_bas11.height + reglage;
			this.addChild(etage2_bas11);
			//
			this.addChild(etage2_haut5);
			//
			this.addChild(etage2_haut6);
			//
			etage2_box8.x = etage2_haut6.x + etage2_haut6.width - etage2_box8.width;
			etage2_box8.y = etage2_haut6.y - etage2_box8.height + 2;
			this.addChild(etage2_box8);
			player.obstacles.addItems(etage2_box8);
			//
			etage2_box9.x = etage2_haut6.x + etage2_haut6.width - etage2_box8.width;
			etage2_box9.y = etage2_box8.y - etage2_box9.height + 5;
			this.addChild(etage2_box9);
			player.obstacles.addItems(etage2_box9);
			//
			etage2_box10.x = etage2_haut6.x + etage2_haut6.width + speedPlayer*12;
			etage2_box10.y = yGroundPosition - etage2_box11.height + reglage;
			this.addChild(etage2_box10);
			player.obstacles.addItems(etage2_box10);
			//
			etage2_box11.x = etage2_haut6.x + etage2_haut6.width + speedPlayer*12;
			etage2_box11.y = etage2_box10.y - etage2_box11.height + 5;
			this.addChild(etage2_box11);
			player.obstacles.addItems(etage2_box11);
			//
			etage2_box12.x = etage2_haut6.x + etage2_haut6.width + speedPlayer*12;
			etage2_box12.y = etage2_box11.y - etage2_box12.height + 5;
			this.addChild(etage2_box12);
			player.obstacles.addItems(etage2_box12);
			
			// ajout du joueur
			this.addChild(player);
			
			// création des flics
			flics = new Flics();
			flics.scaleX = flics.scaleY = .25;
			flics.x = flics.width / 2 - 20;
			flics.y = yGroundPosition - flics.height / 2 + 20;
			flics.sarko.gotoAndPlay("caché");
			this.addChild(flics);
			
			// score
			this.scoreText = scoreText;
			
			// vies
			this.vie1 = new ArbreVie();
			this.vie2 = new ArbreVie();
			this.vie3 = new ArbreVie();
			this.vie1.x = this.vie1.width;
			this.vie1.y = this.vie1.height/2;
			this.vie2.x = this.vie1.width*2 + 5;
			this.vie2.y = this.vie1.height/2;
			this.vie3.x = this.vie1.width*3 + 10;
			this.vie3.y = this.vie1.height/2;
			display.stage.addChild(this.vie1);
			display.stage.addChild(this.vie2);
			display.stage.addChild(this.vie3);
			
			display.stage.addEventListener(KeyboardEvent.KEY_DOWN, onMoveKeyPressed);
			display.stage.addEventListener(KeyboardEvent.KEY_DOWN, onJumpKeyPressed);
			display.stage.addEventListener(KeyboardEvent.KEY_UP, onKeyReleased);
			this.addEventListener(Event.EXIT_FRAME, updateScore);
			this.addEventListener(Event.ENTER_FRAME, zoomScreen);
			this.addEventListener(Event.ENTER_FRAME, entreObstacle);
			this.addEventListener(Event.ENTER_FRAME, showSarko);
			this.addEventListener(Event.ENTER_FRAME, updatePlayer);
			
		}
		
		
		function zoomScreen(event:Event):void {
		if (player.x < 400){
				echelle = -player.x / 300 + 7/3 -1;
				this.y = -480 * echelle + (yGroundPosition - player.height - player.y + 10)/2;

				this.scaleX = echelle+1;
				this.scaleY = echelle+1;
				
			} else {
				echelle = -400 / 300 + 7/3 -1;
				this.y = -480 * echelle + (yGroundPosition - player.height - player.y + 10)/2;

				this.scaleX = echelle+1;
				this.scaleY = echelle+1;
			}

		}
		
		function showSarko(event:Event):void {
			
			if (player.x < flics.x + 2* flics.width) {
				if (isSarkoHided) {
					flics.sarko.gotoAndPlay("sors");
					player.playEtonne();
					isSarkoHided = false;
				}
				
			} else {
				if (isSarkoShowed) {
					flics.sarko.gotoAndPlay("rentre");
					isSarkoShowed = false;
				}
			}
		
			if (flics.sarko.currentFrame == 1) {
				isSarkoHided = true;
			}
			if (flics.sarko.currentFrame == 35) {
				isSarkoShowed = true;
			}
		}
		
		function onMoveKeyPressed(event:KeyboardEvent):void {
			if (event.keyCode == Keyboard.LEFT) {
				display.stage.removeEventListener(KeyboardEvent.KEY_DOWN, onMoveKeyPressed);
				leftKeyIsDown = true;
				player.playRun(1);
			}
			if (event.keyCode == Keyboard.RIGHT) {
				display.stage.removeEventListener(KeyboardEvent.KEY_DOWN, onMoveKeyPressed);
				rightKeyIsDown = true;
				player.playRun(3);
			}
		}
		
		function onJumpKeyPressed(event:KeyboardEvent):void {			
			if (event.keyCode == Keyboard.UP || event.keyCode == Keyboard.SPACE) {
				display.stage.removeEventListener(KeyboardEvent.KEY_DOWN, onJumpKeyPressed);
				upKeyIsDown = true;
				spaceIsDown = true;
			}
		}
		
		function onKeyReleased(event:KeyboardEvent):void {
			if (event.keyCode == Keyboard.LEFT) {
				leftKeyIsDown = false;
				display.stage.addEventListener(KeyboardEvent.KEY_DOWN, onMoveKeyPressed);
				player.playRun();
			}
			if (event.keyCode == Keyboard.RIGHT) {
				rightKeyIsDown = false;
				display.stage.addEventListener(KeyboardEvent.KEY_DOWN, onMoveKeyPressed);
				player.playRun();
				player.playEssoufle();
			}
			if (event.keyCode == Keyboard.UP || event.keyCode == Keyboard.SPACE) {
				upKeyIsDown = false;
				spaceIsDown = false;
				display.stage.addEventListener(KeyboardEvent.KEY_DOWN, onJumpKeyPressed);
			}

		}
		
		function updatePlayer(event:Event):void {			
			if (leftKeyIsDown) {
				player.moveLeft();
				score += slowScoreIncrease;
		
			} else if (rightKeyIsDown) {
				player.moveRight();
				score += fastScoreIncrease;
		
			} else {
				player.stand();
				score += baseScoreIncrease;
			}
				
			if (upKeyIsDown || spaceIsDown) {
				player.jump();
			}
		}
		
		function updateScore(event:Event):void {
			scoreText.textField.text = "SCORE : " + Math.floor(score) + " m";

			if (escapeCounter > 0) {
				escapeCounter--;
				player.x += 2;

			} else if (escapeCounter == 0) {
				removeEscapeMessage();
			}

			if (player.x < xFlicsPosition && escapeCounter == 0) {
				if (player.vies == 0) {
					// fin de partie
					gameOverCallback();

				} else {
					writeEscapeMessage();
					escapeCounter = 30 * 5;
					player.escapeCops();
					if (player.vies == 1) {
						display.stage.removeChild(vie3);
					} else {
						display.stage.removeChild(vie2);
					}
				}
			}
			
			if (player.y > display.stage.stageHeight) {
				gameOverCallback();
			}
		}
		
		function writeEscapeMessage():void {
			escapeMessage = new NiceTextField();
			escapeMessage.x = display.stage.stageWidth / 2 - escapeMessage.width / 2;
			escapeMessage.y = display.stage.stageHeight / 2 - scoreText.height / 2;
			escapeMessage.textField.selectable = false;
			escapeMessage.textField.defaultTextFormat = new TextFormat("Playbill", 48, 0xFFFE65,
											false, false, false, null, null, "center");
			if (player.vies == 1) {
				escapeMessage.textField.text = "5 secondes pour s'échapper grâce à la marseillaise !!\n"
								   + "C'est ta dernière chance !!";
			} else {
				escapeMessage.textField.text = "5 secondes pour s'échapper grâce à la marseillaise !!";
			}
			display.addChild(escapeMessage);
		}

		function removeEscapeMessage():void {
			if (escapeMessage != null) {
				display.removeChild(escapeMessage);
				escapeMessage = null;
			}
		}
		
		function changeXSpeed(o:Obstacle, vitesse:Number):void{
			o.xSpeed = vitesse;
		}
		
		function entreObstacle(event:Event):void {
			var num:Number = 0;
			if(!flecheRightDebut.isOut){
				flecheRightDebut.activeMove();
			}
			
			compteurNiveau = compteurNiveau + 1;
			if(compteurNiveau<700){
				xSpeed = -3;
				speedPlayer = 8;
			} else if (compteurNiveau<1155) {
				xSpeed = -4.62;
				speedPlayer = 9;
			} else if (compteurNiveau<1451){
				xSpeed = -7.11;
				speedPlayer = 10;
			} else if (compteurNiveau < 1643) {
				xSpeed = -10.94;
				speedPlayer = 12;
			}
			
			player.standingSpeed = xSpeed;
			player.baseSpeed = speedPlayer;
			changeXSpeed(deco_stone, xSpeed);
			changeXSpeed(deco_barriere, xSpeed);
			changeXSpeed(deco_flecheRight, xSpeed);
			changeXSpeed(deco_panneau, xSpeed);
			changeXSpeed(deco_plot1, xSpeed);
			changeXSpeed(deco_plot2, xSpeed);
			changeXSpeed(deco_voiture, xSpeed);
			changeXSpeed(flecheRightDebut, xSpeed);
			changeXSpeed(flecheUpDebut, xSpeed);
			changeXSpeed(boite1_1, xSpeed);
			changeXSpeed(boite1_2, xSpeed);
			changeXSpeed(boite1_3, xSpeed);
			changeXSpeed(boite1_4, xSpeed);
			changeXSpeed(boite1_5, xSpeed);
			changeXSpeed(etage1_box1, xSpeed);
			changeXSpeed(etage1_box2, xSpeed);
			changeXSpeed(etage1_box3, xSpeed);
			changeXSpeed(etage1_haut, xSpeed);
			changeXSpeed(etage1_bas, xSpeed);
			changeXSpeed(etage2_box1, xSpeed);
			changeXSpeed(etage2_bas1, xSpeed);
			changeXSpeed(etage2_bas2, xSpeed);
			changeXSpeed(etage2_haut1, xSpeed);
			changeXSpeed(etage2_bas3, xSpeed);
			changeXSpeed(etage2_bas4, xSpeed);
			changeXSpeed(etage2_haut2, xSpeed);
			changeXSpeed(etage2_bas5, xSpeed);
			changeXSpeed(etage2_haut3, xSpeed);
			changeXSpeed(etage2_sac1, xSpeed);
			changeXSpeed(etage2_box2, xSpeed);
			changeXSpeed(etage2_box3, xSpeed);
			changeXSpeed(etage2_box4, xSpeed);
			changeXSpeed(etage2_box5, xSpeed);
			changeXSpeed(etage2_box6, xSpeed);
			changeXSpeed(etage2_box7, xSpeed);
			changeXSpeed(etage2_bas6, xSpeed);
			changeXSpeed(etage2_bas7, xSpeed);
			changeXSpeed(etage2_bas8, xSpeed);
			changeXSpeed(etage2_bas9, xSpeed);
			changeXSpeed(etage2_bas10, xSpeed);
			changeXSpeed(etage2_bas11, xSpeed);
			changeXSpeed(etage2_haut4, xSpeed);
			changeXSpeed(etage2_haut5, xSpeed);
			changeXSpeed(etage2_haut6, xSpeed);
			changeXSpeed(etage2_pierre1, xSpeed);
			changeXSpeed(etage2_pierre2, xSpeed);
			changeXSpeed(etage2_box8, xSpeed);
			changeXSpeed(etage2_box9, xSpeed);
			changeXSpeed(etage2_box10, xSpeed);
			changeXSpeed(etage2_box11, xSpeed);
			changeXSpeed(etage2_box12, xSpeed);
			
			compteur++;
			
			if(compteur > 30*Math.random() + 60){
				compteur = 0;
				//active des objets
				num = Math.random() * 20;
			
				if (num < 1 && boite1Ens){
					boite1_1.activeMove();
					boite1_2.activeMove();
					boite1_3.activeMove();
					boite1_4.activeMove();
					boite1_5.activeMove();
				} else if (num>1 && num<2 && etage1Ens){
					etage1_box1.activeMove();
					etage1_box2.activeMove();
					etage1_box3.activeMove();
					etage1_haut.activeMove();
					etage1_bas.activeMove();
				} else if (num>2 && num<3){
					deco_stone.activeMove();
				} else if (num>3 && num<4){
					deco_barriere.activeMove();
				} else if (num>4 && num<5){
					deco_voiture.activeMove();
				} else if (num>5 && num<6){
//					deco_panneau.activeMove();
				} else if (num>6 && num<7){
					deco_plot1.activeMove();
				} else if (num>7 && num<8){
					deco_plot2.activeMove();
				} else if (num>8 && num<8.5){
					deco_flecheRight.activeMove();
				}

				
				if(etage2Ens){
					flecheUpDebut.activeMove();
					etage2_box1.activeMove();
					etage2_bas1.activeMove();
					etage2_bas2.activeMove();
					etage2_haut1.activeMove();
					etage2_bas3.activeMove();
					etage2_bas4.activeMove();
					etage2_haut2.activeMove();
					etage2_bas5.activeMove();
					etage2_haut3.activeMove();
					etage2_pierre1.activeMove();
					etage2_pierre2.activeMove();
					etage2_sac1.activeMove();
					etage2_box2.activeMove();
					etage2_box3.activeMove();
					etage2_box4.activeMove();
					etage2_box5.activeMove();
					etage2_box6.activeMove();
					etage2_box7.activeMove();
					etage2_bas6.activeMove();
					etage2_bas7.activeMove();
					etage2_bas8.activeMove();
					etage2_bas9.activeMove();
					etage2_bas10.activeMove();
					etage2_bas11.activeMove();
					etage2_haut4.activeMove();
					etage2_haut5.activeMove();
					etage2_haut6.activeMove();
					etage2_box8.activeMove();
					etage2_box9.activeMove();
					etage2_box10.activeMove();
					etage2_box11.activeMove();
					etage2_box12.activeMove();
				}
				
				if (deco_stone.isOut){
					deco_stone.x = 1500;
					deco_stone.isOut = false;
				}
				
				if (deco_barriere.isOut){
					deco_barriere.x = 1500;
					deco_barriere.isOut = false;
				}
				if (deco_voiture.isOut){
					deco_voiture.x = 1500;
					deco_voiture.isOut = false;
				}
				if (deco_panneau.isOut){
					deco_panneau.x = 1500;
					deco_panneau.isOut = false;
				}
				if (deco_plot1.isOut){
					deco_plot1.x = 1500;
					deco_plot1.isOut = false;
				}
				if (deco_plot2.isOut){
					deco_plot2.x = 1500;
					deco_plot2.isOut = false;
				}
				if (deco_flecheRight.isOut){
					deco_flecheRight.x = 1500;
					deco_flecheRight.isOut = false;
				}
				
				
				
				
				//pour les boites combines
				if (boite1_5.isOut){
				boite1Ens = false;
					boite1_1.x = 1500;
					boite1_1.isOut = false;
					boite1_2.x = boite1_1.x + boite1_1.width;
					boite1_2.isOut = false;
					boite1_3.x = boite1_2.x + boite1_2.width;
					boite1_3.isOut = false;
					boite1_4.x = boite1_3.x + boite1_3.width;
					boite1_4.isOut = false;
					boite1_5.x = boite1_4.x + boite1_4.width;
					boite1_5.isOut = false;
					boite1Ens = true;
				}
				
				//pour le petit saut
				
				if (etage1_box3.isOut){
					etage1Ens = false;
					etage1_box1.x = 1500;
					etage1_box1.isOut = false;
					etage1_haut.x = etage1_box1.x + etage1_box1.width + speedPlayer*10;
					etage1_haut.isOut = false;
					etage1_bas.x = etage1_haut.x + etage1_haut.width/2 - etage1_bas.width/2;
					etage1_bas.isOut = false;
					etage1_box2.x = etage1_haut.x + etage1_haut.width + speedPlayer*10;
					etage1_box2.isOut = false;
					etage1_box3.x = etage1_haut.x + etage1_haut.width + speedPlayer*10;
					etage1_box3.isOut = false;
					etage1Ens = false;
				}
				
				//pour le grand niveau
				
				if (etage2_bas10.isOut){
					etage2Ens = false;
					flecheUpDebut.x = 1350;
					flecheUpDebut.isOut = false;
					etage2_box1.x = 1500;
					etage2_box1.isOut = false;
					etage2_haut1.x = etage2_box1.x + etage2_box1.width + speedPlayer*7;
					etage2_haut1.isOut = false;
					etage2_bas1.x = etage2_haut1.x + etage2_haut1.width/5 - etage2_bas1.width/2;
					etage2_bas1.isOut = false;
					etage2_bas2.x = etage2_haut1.x + etage2_haut1.width*4/5 - etage2_bas1.width/2;
					etage2_bas2.isOut = false;
					etage2_haut2.x = etage2_haut1.x + etage2_haut1.width + speedPlayer*10;;
					etage2_haut2.isOut = false;
					etage2_bas3.x = etage2_haut2.x + etage2_haut2.width/4 - etage2_bas3.width/2;
					etage2_bas3.isOut = false;
					etage2_bas4.x = etage2_haut2.x + etage2_haut2.width*4/5 - etage2_bas4.width/2;
					etage2_bas4.isOut = false;
					etage2_bas5.x = etage2_haut2.x + etage2_haut2.width/4 - etage2_bas3.width/2;
					etage2_bas5.isOut = false;
					etage2_haut3.x = etage2_bas5.x - 20;
					etage2_haut3.isOut = false;
					etage2_pierre1.x = etage2_haut3.x + etage2_haut3.width - 20;
					etage2_pierre1.isOut = false;
					etage2_sac1.x = etage2_pierre1.x + etage2_pierre1.width;
					etage2_sac1.isOut = false;
					etage2_box2.x = etage2_haut2.x + etage2_haut2.width + speedPlayer*10;
					etage2_box2.isOut = false;
					etage2_box3.x = etage2_haut2.x + etage2_haut2.width + speedPlayer*10;
					etage2_box3.isOut = false;
					etage2_box4.x = etage2_box2.x + etage2_box2.width + speedPlayer*10;
					etage2_box4.isOut = false;
					etage2_box5.x = etage2_box2.x + etage2_box2.width + speedPlayer*10;
					etage2_box5.isOut = false;
					etage2_box6.x = etage2_box4.x + etage2_box4.width + speedPlayer*10;
					etage2_box6.isOut = false;
					etage2_box7.x = etage2_box4.x + etage2_box4.width + speedPlayer*10;
					etage2_box7.isOut = false;
					etage2_haut4.x = etage2_box6.x + etage2_box6.width + speedPlayer*10;;
					etage2_haut4.isOut = false;
					etage2_bas6.x = etage2_haut4.x + etage2_haut4.width/5 - etage2_bas6.width/2;
					etage2_bas6.isOut = false;
					etage2_bas7.x = etage2_haut4.x + etage2_haut4.width*4/5 - etage2_bas7.width/2;
					etage2_bas7.isOut = false;
					etage2_bas8.x = etage2_haut4.x + etage2_haut4.width*4/5 - etage2_bas8.width/2;
					etage2_bas8.isOut = false;
					etage2_haut5.x = etage2_bas8.x - 20;
					etage2_haut5.isOut = false;
					etage2_bas9.x = etage2_haut5.x + etage2_haut5.width*2/3 - etage2_bas9.width/2;
					etage2_bas9.isOut = false;
					etage2_haut6.x = etage2_bas9.x - 10;
					etage2_haut6.isOut = false;
					etage2_bas10.x = etage2_haut6.x + etage2_haut6.width*3/4 - etage2_bas10.width/2;
					etage2_bas10.isOut = false;
					etage2_pierre2.x = etage2_bas9.x - etage2_pierre2.width - 50;
					etage2_pierre2.isOut = false;
					etage2_bas11.x = etage2_haut6.x + etage2_haut6.width*3/4 - etage2_bas10.width/2;
					etage2_bas11.isOut = false;
					etage2_box8.x = etage2_haut6.x + etage2_haut6.width - etage2_box8.width;
					etage2_box8.isOut = false;
					etage2_box9.x = etage2_haut6.x + etage2_haut6.width - etage2_box8.width;
					etage2_box9.isOut = false;
					etage2_box10.x = etage2_haut6.x + etage2_haut6.width + speedPlayer*12;
					etage2_box10.isOut = false;
					etage2_box11.x = etage2_haut6.x + etage2_haut6.width + speedPlayer*12;
					etage2_box11.isOut = false;
					etage2_box12.x = etage2_haut6.x + etage2_haut6.width + speedPlayer*12;
					etage2_box12.isOut = false;
					etage2Ens = true;
					
				}
				
			}
			
		}
		
		public function dispose():void {
			var i:Number = 0;
			var child:DisplayObject;

			player.visible = false;

			// remove children
			for (i = 0; i < this.numChildren; i++) {
				child = this.getChildAt(i);
				this.removeChildAt(i);
			}

			display.stage.removeChild(vie1);

			display.stage.removeEventListener(KeyboardEvent.KEY_DOWN, onMoveKeyPressed);
			display.stage.removeEventListener(KeyboardEvent.KEY_DOWN, onJumpKeyPressed);
			display.stage.removeEventListener(KeyboardEvent.KEY_UP, onKeyReleased);
			this.removeEventListener(Event.EXIT_FRAME, updateScore);
			this.removeEventListener(Event.ENTER_FRAME, entreObstacle);
			this.removeEventListener(Event.ENTER_FRAME, zoomScreen);
			this.removeEventListener(Event.ENTER_FRAME, updatePlayer);

			// reset zoom
			this.scaleX = 1;
			this.scaleY = 1;
		}
	}
}
