﻿package game {
	import game.*;
	import flash.display.*;
	import flash.display.DisplayObjectContainer;
	import flash.system.System;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.events.*;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	
	public class SelectionPerso extends MovieClip {
		
		var display:DisplayObjectContainer;
		var screen:SelectionPersoScreen = null;
		var chinois:Boolean = false;
		var rasta:Boolean = false;
		var arabe:Boolean = false;

		public function SelectionPerso(display:DisplayObjectContainer):void {
			this.display = display;
			
			this.screen = new SelectionPersoScreen();
			this.screen.x = this.display.stage.stageWidth / 2;
			this.screen.y = this.display.stage.stageHeight / 2;
			this.display.addChild(this.screen);
			
			this.display.stage.addEventListener(KeyboardEvent.KEY_DOWN, pressKey);
			this.display.stage.addEventListener(KeyboardEvent.KEY_UP, releaseKey);
			
			this.gotoAndPlay("Chinois");
			this.chinois=true;
		}

		function pressKey(event:KeyboardEvent):void {
			this.display.stage.removeEventListener(KeyboardEvent.KEY_DOWN, pressKey);
			
			if (event.keyCode == Keyboard.LEFT) {
				if (this.chinois) {
					this.changeCharacter("Rasta");
					this.chinois = false ;
					this.rasta = true;
				}
				
				else if (this.rasta) {
					this.changeCharacter("Arabe");
					this.arabe =true;
					this.rasta = false;
				}
				
				else if (this.arabe) {
					this.changeCharacter("Chinois");
					this.chinois=true;
					this.arabe=false;
				}
					
			}
			if (event.keyCode == Keyboard.RIGHT) {
				if (this.chinois) {
					this.changeCharacter("Arabe");
					this.arabe =true;
					this.chinois = false;
				}
				
				else if (this.rasta) {
					this.changeCharacter("Chinois");
					this.rasta = false;
					this.chinois = true;
				}
				
				else if (this.arabe) {
					this.changeCharacter("Rasta");
					this.rasta=true;
					this.arabe=false;
				}
				
			}
		
		}
		
		function releaseKey(event:KeyboardEvent):void {
			this.display.stage.addEventListener(KeyboardEvent.KEY_DOWN, pressKey);
			if (event.keyCode == Keyboard.LEFT || event.keyCode == Keyboard.RIGHT || event.keyCode == Keyboard.UP || event.keyCode == Keyboard.DOWN) {
			}
			if (event.keyCode == Keyboard.DOWN) {
			}
		}
		
		function changeCharacter (nom:String) : void {
			this.screen.gotoAndPlay(nom);
		}
		
		public function dispose():void {
			this.screen.gotoAndStop("stopped");
			this.screen.stop();
			this.display.removeChild(this.screen);
			this.screen = null;
			this.display.stage.removeEventListener(KeyboardEvent.KEY_DOWN, pressKey);
			this.display.stage.removeEventListener(KeyboardEvent.KEY_UP, releaseKey);
		}
	}
}
